#include	<pic18.h>
#include	"lcd.h"
#include    "delay.h"


 
#define	PORTBIT(Adr, Bit)	((unsigned)(&Adr)*8+(Bit)) 
static bit LCD_RS	@ PORTBIT(PORTB, 0);	// Register select
static bit LCD_EN	@ PORTBIT(PORTB, 1);	// Enable
#define	LCD_STROBE	((LCD_EN = 1),(LCD_EN=0))

//DB7=RB5   DB6=RB4   DB5=RB3   DB4=RB2

#define DEFINED_CHAR 5

/* write a byte to the LCD in 4 bit mode */

void
lcd_write(unsigned char c)
{
	CLRWDT();
	
	PORTB = (PORTB & 0xC3) |  ( (c >> 2)& 0xFC );
	LCD_STROBE;
	PORTB = (PORTB & 0xC3) |  ((c & 0x0F)<<2);
	LCD_STROBE;
	DelayUs(40);
}

/*
 * 	Clear and home the LCD
 */

void
lcd_clear(void)
{
	CLRWDT();
	
	LCD_RS = 0;
	lcd_write(0x1);
	DelayMs(2);
}


/* write one character to the LCD */

void
lcd_putch(char c)
{
	if(c=='') c=1;else
	if(c=='') c=2;else
	if(c=='') c=3;else
	if(c=='') c=4;else
	if(c=='') c=0xF5; else
	if(c=='') c=0xEF;

	LCD_RS = 1;	// write characters
	PORTB = (PORTB & 0xC3) |  ( (c >> 2)& 0xFC );
	LCD_STROBE;
	PORTB = (PORTB & 0xC3) |  ((c & 0x0F)<<2);
	LCD_STROBE;
	DelayUs(40);
}


/*
 * Go to the specified position
 */

void
lcd_goto(unsigned char pos)
{
	CLRWDT();
	
	LCD_RS = 0;
	lcd_write((0x80+pos));
}

	
/* initialise the LCD - put into 4 bit mode */

void
lcd_init(void)
{
	CLRWDT();
	
	LCD_RS = 0;	// write control bytes
	DelayMs(15);	// power on delay
	PORTB = ((0x3)<<2);	// attention!
	LCD_STROBE;
	DelayMs(5);
	LCD_STROBE;
	DelayUs(100);
	LCD_STROBE;
	DelayMs(5);
	PORTB = ((0x2)<<2);	// set 4 bit mode
	LCD_STROBE;
	DelayUs(40);
	lcd_write(0x28);	// 4 bit mode, 1/16 duty, 5x8 font
	lcd_write(0x08);	// display off
	lcd_write(0x0F);	// display on, blink curson on
	lcd_write(0x06);	// entry mode
}


