/*       ͻ
             TITLE:  Hitech PICC18 v.8.35PL3 port of Adam Dunkels' uIP v0.9 
          REVISION:  VER 0.1                                                
          REV.DATE:  21-07-05                                               
           ARCHIVE:                                                         
            AUTHOR:  Copyright (c) 2005, Engin Karabulut.                   
         ͼ    */

/*  Ŀ
      THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS   
      OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED   
      WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE  
      ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY     
      DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  
      DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE   
      GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS       
      INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,        
      WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           
      NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS  
      SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.        
      */

/*  ͻ
                                                                         
     -application:                                                       
                                                                         
     Simple Web Server telemetry application.                            
                                                                         
                                                                         
    ͼ  */

/*****************************************************************************/


#include <pic18.h>
#include "salvocfg.h"
#include <salvo.h>
#include "delay.h"
#include "clk_freq.h"
#include "ne2000.h"  
#include "I2C.h"
#include "lcd.h"
#include "main.h"
#include "httpd.h"

__CONFIG(1, HSPLL );  //config bits
__CONFIG(2, PWRTDIS & BORDIS & WDTDIS);
__CONFIG(4, STVRDIS & LVPDIS & DEBUGEN);
__CONFIG(5, UNPROTECT);
__CONFIG(7, TRU & SWDTDIS); 

unsigned char  alias[] = "PIC WEBSERVER IS";  //some variables that used by tasks
unsigned char  name[] =  "RUNNING-5091(IO)";
unsigned char temper[9];
unsigned char data2,data1,swap1,swap2;
unsigned char On1,On2,On3,On4,Z;

/* task defines                  */
#define TASK1_P	  	OSTCBP(1)  /* task #1        */
#define TASK2_P	  	OSTCBP(2)  /* task #2        */
#define TASK3_P	 	OSTCBP(3)  /* task #3        */
#define TASK4_P	 	OSTCBP(4)  /* task #4        */
#define TASK5_P	 	OSTCBP(5)  /* task #5        */
#define BINSEM1_P	OSECBP(1)  /* semaphore #1   */
#define BINSEM2_P	OSECBP(2)  /* semaphore #2   */

/* use _OSLabel() to create context-switching labels.	*/
_OSLabel(Task1a)
_OSLabel(Task2a)
_OSLabel(Task3a)
_OSLabel(Task4a)
_OSLabel(Task5a)
_OSLabel(Task6a)
_OSLabel(Task7a)
_OSLabel(Task8a)
_OSLabel(Sem1)
_OSLabel(Sem2)

/////////////////////////////////////////////////////////////////////////
void TaskDoUIP(void) /*Salvo Task to Implement uIP TCP/IP Stack */
{
   for (;;)
   {
   uip_len = nic_begin_packet_rx();
if(uip_len > 0)
{
 receive();
 switch(BUF->type)
 {     case 0x800:
       {
	     uip_arp_ipin();
	     uip_input();
	        if(uip_len > 0)
            {
	          uip_arp_out();
	          send_packet();
	        }         
       }
       case 0x806:
       {
	      uip_arp_arpin();
	       if(uip_len > 0)
           {	
	       send_packet();
	       }
       }
 }

}
OS_Delay(10,Task1a);  /*runs  every 10 ms */
   }
}
/////////////////////////////////////////////////////////////////////////
void TaskDoUIPPeriodic(void)  /*checks all of the open connections every 500ms for activity */
{
   unsigned char i;
   for (;;)
   {
     for(i = 0; i < UIP_CONNS; ++i)
     {
       uip_periodic(i);
       if(uip_len > 0)
       {
       uip_arp_out();
       send_packet();
       }
     }
   OS_Delay(250,Task2a); /*runs  every 500 ms */
   OS_Delay(250,Task3a);
   }
}
/////////////////////////////////////////////////////////////////////////
void temp( void ) /* temperature measurement task with DS75 I2C temperature sensor */
{
	static unsigned char k;
	for (;;) {
        i2c_start();
        i2c_write(0x91);
        data1=i2c_read(1);
        DelayMs(1);
        data2=i2c_read(0);
        i2c_stop();  
        data1= (data1 & 0x7F);
	    data1= bin2bcd(data1);
	    swap1=data1;
	    swap1 = swap1 & 0x0F;
	    swap1 = swap1 | 0x30;
	    swap2=data1;
	    swap2= swap2 >> 4; 
	    swap2 = swap2 | 0x30;
        decimal();
        for(k=0;k<4;k++)
        {   
    	OS_Delay(250, Task4a);  /*runs  every 1 second */	
       	}
     }
}
/////////////////////////////////////////////////////////////////////////
void lcd( void ) /* HD44780 compatible LCD task #1 */
{
 static unsigned char i;
	for (;;) {
		OS_WaitBinSem(BINSEM1_P,0,Task5a); //wait sem1 signal to run
		lcd_clear();
        lcd_putch('T');
        lcd_putch('e');
        lcd_putch('m');
        lcd_putch('p');
        lcd_putch('e');
        lcd_putch('r');
        lcd_putch('a');
        lcd_putch('t');       
        lcd_putch('u');
        lcd_putch('r');
        lcd_putch('e');
        lcd_putch(':');
        lcd_goto(64);
        lcd_putch(swap2);
    	lcd_putch(swap1);
        lcd_putch('.');
        lcd_putch(On1);
        lcd_putch(On2);
        lcd_putch(On3);
        lcd_putch(On4);
        lcd_putch(0xDF);    
        lcd_putch('C');
        temper[0] = swap2;
        temper[1] = swap1;
        temper[2] = '.';
        temper[3] = On1;
        temper[4] = On2;
        temper[5] = On3;
        temper[6] = On4;
        temper[7] = 0xB0;    
        temper[8] = 'C';
        for(i=0;i<8;i++)
        {   
    	OS_Delay(250, Task6a);	/*runs  every 2 second */
        }
        OSSignalBinSem(BINSEM2_P); //signal sem2
   }
}
/////////////////////////////////////////////////////////////////////////
void lcd2( void )  /* HD44780 compatible LCD task #1 */
{
    static unsigned char l;
	for (;;)
    {
	    OS_WaitBinSem(BINSEM2_P,0,Task7a);  //wait sem2 signal to run
        lcd_clear();
        l=0;
         while(alias[l] != '\0' )
         { lcd_putch( alias[l]);
           l++;
         }
        lcd_goto(64);
        l=0;
         while(name[l] != '\0')
         { lcd_putch(name[l]);
           l++;
         }
        for(l=0;l<8;l++)
        {   
        OS_Delay(250, Task8a);	/*runs  every 2 second */
        }
        OSSignalBinSem(BINSEM1_P);  //signal sem2
    }
    
}

int main( void )
{
	init_ports(); //init ports and SFRs	
	lcd_init();   //init HD44780 compatible lcd 
	lcd_clear();  //clear lcd
    i2c_init();   //init DS75 temp. sensor
    uip_init();   //init uIP
    httpd_init(); // start HTTP on port 80
    hard_reset(); //reset NIC   
    nic_init();   //init NIC
    /* initialize Salvo operating System.	    		*/	
	OSInit();
	 
	/* create the five tasks                			*/
	OSCreateTask(TaskDoUIP, TASK1_P, 2);
	OSCreateTask(TaskDoUIPPeriodic, TASK2_P, 2);
	OSCreateTask(temp, TASK3_P, 4);
	OSCreateTask(lcd, TASK4_P, 3);
	OSCreateTask(lcd2, TASK5_P, 3);	
	/* initialize binary semaphores     	 			*/
	OSCreateBinSem(BINSEM1_P,1);
    OSCreateBinSem(BINSEM2_P,0);
	/* start multitasking.								*/
	for (;;)
     OSSched(); //infinite loop,salvo's scheduler takes control.
}

/************************************************************
****                                                     ****
**                                                         **
intVector()

Periodic interrupt via Timer0 every 256 cycles. To call
OSTimer at 1kHz (every 1ms), a prescalar is used. 40MHz 
clock (0.1us instruction cycle) is assumed. 

**                                                         **
****                                                     ****
************************************************************/
void interrupt IntVector( void )
{
	static char i = 39; /* prescalar, 39 x 25,6us = 1ms	*/
	
	
	if ( TMR0IE && TMR0IF ) {
		TMR0IF = 0;
					
		if ( !(--i) ) {
			/* re-load prescalar.						*/
			i = 39;
			
			/* call Salvo's timer in order to process 	*/
			/* delayed tasks.							*/
			OSTimer();
		}
	}
}
////////////////////////////////////////////////////////////////////////////
void init_ports(void)
{
	ADCON0 = 0;
	ADCON1 = 0B00000110;	// disable analog inputs(E0, E1, E2)	
	TRISA = 0x00; //address bus,initialize as output
	TRISB = 0b00000000; //lcd bus
	TRISC = 0xFB;  //serial line, used for bootloader(if you use).
	TRISD = 0xFF;  //NIC data bus-8 bit.(bidirectional) 
	TRISE = 0x00;  // RE0-> -IOR , RE1-> -IOW ,RE2-> RESET
    //initial conditions
	PORTA = 0;
	PORTB = 0;
	PORTC = 0x04;
	PORTD = 0;
	PORTE = 0b00000011; 
	TMR0   = 0;
	T0CS = 0;
    IPEN = 0;
	PIE1=0;
    INTCON = 0b10100000;	// GIE and TMR0IE Interrupt active
}
/////////////////////////////////////////////////////////////////////////
char bin2bcd(char binary_value)  /* binary to BCD converter */
{ 
char temp; 
char retval; 

temp = binary_value; 
retval = 0; 

while(1) 
{ 
if(temp >= 10) 
{ 
temp -= 10; 
retval += 0x10; 
} 
else 
{ 
retval += temp; 
break; 
} 
} 

return(retval); 
} 
/////////////////////////////////////////////////////////////////////////
void decimal(void) /*decimal calculation of DS75 sensor */
{
  data2 == data2&0xF0;
  switch(data2)
  {
      case 0x00:{On1=0x30; On2=0x30; On3=0x30; On4=0x30; break;}
      case 0x10:{On1=0x30; On2=0x36; On3=0x32; On4=0x35; break;}
      case 0x20:{On1=0x31; On2=0x32; On3=0x35; On4=0x30; break;}
      case 0x30:{On1=0x31; On2=0x38; On3=0x37; On4=0x35; break;}
      case 0x40:{On1=0x32; On2=0x35; On3=0x30; On4=0x30; break;}
      case 0x50:{On1=0x33; On2=0x31; On3=0x32; On4=0x35; break;}
      case 0x60:{On1=0x33; On2=0x37; On3=0x35; On4=0x30; break;}
      case 0x70:{On1=0x34; On2=0x33; On3=0x37; On4=0x35; break;}
      case 0x80:{On1=0x35; On2=0x30; On3=0x30; On4=0x30; break;}
      case 0x90:{On1=0x35; On2=0x36; On3=0x32; On4=0x35; break;}
      case 0xA0:{On1=0x36; On2=0x32; On3=0x35; On4=0x30; break;}
      case 0xB0:{On1=0x36; On2=0x38; On3=0x37; On4=0x35; break;}
      case 0xC0:{On1=0x37; On2=0x35; On3=0x30; On4=0x30; break;}
      case 0xD0:{On1=0x38; On2=0x31; On3=0x32; On4=0x35; break;}
      case 0xE0:{On1=0x38; On2=0x37; On3=0x35; On4=0x30; break;}
      case 0xF0:{On1=0x39; On2=0x33; On3=0x37; On4=0x35; }
  }
}
/////////////////////////////////////////////////////////////////////////
void receive(void) //receive NIC data,copy to uIP buffer
{
  unsigned int len1;
  len1 = nic_begin_packet_rx();
  nic_packet_get_data(len1);
  nic_end_packet_rx();
}
//////////////////////////////////////////////////////////////////////////
